module Data.IdentShow where

import List
import Char


escapeChar c
    | c >= 'a' && c <= 'z' ||
      c >= 'A' && c <= 'Z' ||
      c >= '0' && c <= '9' ||
      c == '_'
                                = [c]
    | otherwise                 = "char" ++ (show $ ord c)

class IdentShow a where
    identShow :: a -> String
    identShowList :: [a] -> String
    identShowList l = "(" ++ (concat $ intersperse ", " $ map identShow l) ++ ")"

instance IdentShow Char where
    identShow c = escapeChar c
    identShowList s = concatMap escapeChar s

instance IdentShow Int where
    identShow = show

instance IdentShow a => IdentShow [a] where
    identShow = identShowList


