module Data.Term.TRSInfo where

import Data.Map (Map)
import qualified Data.Map as M
import Data.Set (Set)
import qualified Data.Set as S

import Data.Term
import Data.Types.Types

data TRSInfo sym var = TRSInfo {
    tiTRS :: TRS sym var,
    tiArity :: Map sym Int,
    tiSymbols :: Set sym,
    tiConstructor :: Set sym,
    tiDefined :: Set sym,
    tiSimpleTypes :: Map sym (SimpleType Int)
} deriving Show

-- buildTRSInfo :: Ord sym => TRS sym var -> TRSInfo sym var
buildTRSInfo trs = TRSInfo {
    tiTRS = trs,
    tiArity = ars,
    tiSymbols = syms,
    tiConstructor = cons,
    tiDefined = defs,
    tiSimpleTypes = inferSimpleTypes trs (S.toList $ S.union defs cons) ars
}
  where
    (defs, cons) = symbols trs
    syms = S.union defs cons
    ars = arities trs


